#!/usr/bin/perl -w

use strict;
use SOAP::Lite;
use XML::RSS;
use Encode qw/ from_to /;

my $amazon_search = 
     SOAP::Lite->service('http://soap.amazon.co.jp/schemas3/AmazonWebServices.wsdl');

my $dev_token='**************'; ### subscripition ID
my $query = "vw"; # L[[h
from_to($query,'shiftjis','utf-8');

my $results = $amazon_search -> 
    KeywordSearchRequest(
        SOAP::Data->name("KeywordSearchRequest")
                  ->type("KeywordRequest")
                  ->value(\SOAP::Data->value(
                               SOAP::Data->name("keyword" => $query),
                               SOAP::Data->name("page" => "1"),
                               SOAP::Data->name("mode" => "books-jp"),
                               SOAP::Data->name("tag" => '9999'), # A\VGCgĂȂΓK
                               SOAP::Data->name("type" => "lite"),
                               SOAP::Data->name("devtag" => $dev_token),
                               SOAP::Data->name("locale" => "jp")
                           ))
    );

my $rss = new XML::RSS (version => '1.0');

utf8::decode($query);
my $title = "Amazon Search for \"$query\" ";  utf8::encode($title);
my $desc  = "Amazon search results for \"$query\""; utf8::encode($desc);

$rss->channel( title => $title,
               link  => "http://www.amazon.co.jp",
               description => $desc,
               language => "ja");

foreach my $ele (@{$results->{'Details'}}) {

    my $author = shift(@{$ele->{'Authors'}});
    while(my $a = shift(@{$ele->{'Authors'}})) {
        $author = $author.", $a";
    }
    utf8::encode($author);
    my $title     = $ele->{'ProductName'}; utf8::encode($title);
    my $publisher = $ele->{'Manufacturer'}; utf8::encode($publisher);

    $rss->add_item(
                   title  =>  $title,
                   link   =>  "http://www.amazon.co.jp/exec/obidos/ASIN/".$ele->{'Asin'},
                   dc => {
                            publisher  =>  $publisher,
                            creator    =>  $author,
                            date       =>  $ele->{'ReleaseDate'}
                          }
                   );
}

$rss->save("amazon-api.rdf");
# print $rss->as_string;
