#!/usr/bin/perl -w

use strict;
use LWP::Simple;
use XML::RSSLite;
use Encode qw/ from_to /;
use Encode::Guess;

my $url = shift;
my $content = get($url);

my %results = ();
parseRSS( \%results, \$content );

my $channel = $results{'channel'};
print "=== Channel ===\n",
    "Title: ",tosjis($channel->{'title'}),"\n",
    "Desc:  ",tosjis($channel->{'description'}),"\n",
    "Link:  $channel->{'link'}\n";

for my $item (@{$results{'items'}}) {
  print "  --- Item ---\n",
        "  Title: ",tosjis($item->{'title'}),"\n",
        "  Desc:  ",tosjis($item->{'description'}),"\n",
        "  Link:  $item->{'link'}\n\n";
}
  
sub tosjis {
    my($data)  = @_;
    my $enc  = Encode::Guess->guess($data);
    if (ref($enc)) {
        from_to($data,$enc->name,'shiftjis');
    } else {
        from_to($data,'utf-8','shiftjis');
    }
    return $data;
}
