#!/usr/bin/perl -w

use strict;
use XML::RSS;
use LWP::Simple;
use XML::RSS::Timing;

my $url = shift;
my $content = get($url);
my $rss = new XML::RSS;
$rss->parse($content);

my $timing = XML::RSS::Timing->new;

$timing->lastPolled(time());
my $upp = $rss->{'channel'}->{'syn'}->{'updatePeriod'};
if (defined($upp)) {
    $timing->updatePeriod($upp);
} else {
    $timing->updatePeriod('hourly');
}
my $upf = $rss->{'channel'}->{'syn'}->{'updateFrequency'};
$timing->updateFrequency($upf) if defined($upf);
my $upb = $rss->{'channel'}->{'syn'}->{'updateBase'};
$timing->updateBase($upb) if defined($upb);

my $then = $timing->nextUpdate;
print scalar(localtime($then)),"\n";
